/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ᥤ롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Sep.14.2001  Programing start (Particle test 01)

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit          -- ᥤץʤ
  RRMain              -- ֤˥뤵ᥤ
  RRMainFree          -- ᥤץཪλ()
  RRMainWindowSize    -- եå
  RRMainInterval      -- ߻֤
  RRMainIntervalTime  -- ߻֤ɤߤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk-pixbuf/gdk-pixbuf-loader.h>
#include <png.h>
#include  "rr_main.h"
#include  "rr_screen.h"
#include  "v_effect01.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- 󥰷̤ PNG ǽϤ뤫ɤ */
#define  PNGSAVE  0

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  png_save(GdkPixbuf *pic, gchar *fname);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/*--- local timer */
glong timer, lap;
time_t segment;
struct timeval utime;

/* --- ǥץ쥤ݻ */
gint  fw, fh;

/* --- ߤγ */
gint  interval;
gint  int_handle;


/* --- ƥɽѲ */
static GdkPixbuf  *character;

/* --- ե졼 */
static GdkPixbuf  *screen;


void framebuffer_disp(GdkPixbuf*);


/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  timer = 0;
  lap = 0;
  int_handle = 0;
  segment = time(NULL);

  /* -- ߳ */
#if (PNGSAVE == 0)
  RRMainInterval(15);
#else
  RRMainInterval(10);
#endif

  /* -- ¸ɤ߹ */
  character = gdk_pixbuf_new_from_file("../picture/niselina_test.png");

  /* -- ե졼Хåե */
  screen = gdk_pixbuf_new(GDK_COLORSPACE_RGB, TRUE, 8, 640, 480);
  gdk_pixbuf_add_alpha(screen, FALSE, 0, 0, 0);

  /* -- ӥǥեȽ */
  v_effect_init(character);

  /* -- 󥰥󥸥 */
  gdk_rgb_init();
}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (int_handle != 0) gtk_idle_remove(int_handle);
  v_effect_free();
}


/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  fw = w;
  fh = h;
}


/* -------------------------------------------------------------
  RRMainInterval   -- ߻֤

   return : void
   gint n(1/n sec)
-------------------------------------------------------------- */
void RRMainInterval(gint n)
{
  if (int_handle != 0) gtk_idle_remove(int_handle);
  int_handle = gtk_idle_add((GtkFunction)RRMain, NULL);
  /* --- ͤݻ */
  interval = n;
}


/* -------------------------------------------------------------
  RRMainIntervalTime  -- ߻֤ɤߤ

   return : n (1/n sec)
   void
-------------------------------------------------------------- */
gint RRMainIntervalTime(void)
{
  return(interval);
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  gchar tmp[128], info[128];
  GtkStatusbar *stat;

  gettimeofday(&utime, NULL);
  lap = (utime.tv_sec * 1000000) + utime.tv_usec;

  timer++;

  /* -- եȥ */
  v_effect_main(screen, timer);

  /* -- PNG save */
#if (PNGSAVE == 1)
  sprintf(tmp, "flame%04d.png", timer);
  png_save(screen, tmp);
#endif

  /* -- ե졼Хåեɽ */
  framebuffer_disp(screen);

  gettimeofday(&utime, NULL);

  /* --- ®٤ä㡼 */
  gettimeofday(&utime, NULL);
  /* --- StatusBar ˾ɽ */
  stat = GTK_STATUSBAR(RRGetParts(RRGetParts(RRScreenWindow(), "vbox1"), "statusbar1"));
  sprintf(info, "frame %6d : %d/MicroSec.", timer, (((utime.tv_sec * 1000000) + utime.tv_usec) - lap));
  gtk_statusbar_push(stat, gtk_statusbar_get_context_id(stat, tmp), info);

  /* --- ޤ */
  if (timer > 600) {
    RRMainFree();
    gtk_main_quit();
  }

  return 1;
}


void  framebuffer_disp(GdkPixbuf *disp_screen)
{
  GdkGC     *gc;
  gint  w, h;
  GdkPixmap *pic;

  w = gdk_pixbuf_get_width(disp_screen);
  h = gdk_pixbuf_get_height(disp_screen);
  pic = RRScreenCanvas()->window;
  gc = gdk_gc_new(pic);
  gdk_pixbuf_render_to_drawable(disp_screen, pic, gc,
				0, 0, 0, 0, w, h,
				GDK_RGB_DITHER_NONE, 0, 0);
  gdk_gc_destroy(gc);
  /* flush screen */
  gdk_flush();
}



/* ----------------------------------------------------
  GDKPixbuf PNGǥ֤
  ------------------------------------------------------*/
void  png_save(GdkPixbuf *pic, gchar *fname)
{
  FILE *fp;
  png_structp png_ptr;
  png_infop info_ptr;

  fp = fopen(fname, "wb");
  if (fp == NULL) {
    return;
  }

  png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING,
                                    NULL, NULL, NULL);

  if (png_ptr == NULL) {
    fclose(fp);
    return;
  }

  info_ptr = png_create_info_struct(png_ptr);
  if (info_ptr == NULL) {
    fclose(fp);
    png_destroy_write_struct(&png_ptr, (png_infopp)NULL);
    return;
  }

  if (setjmp(png_ptr->jmpbuf)) {
    fclose(fp);
    png_destroy_write_struct(&png_ptr,  (png_infopp)NULL);
    return;
  }

  /* ----- libpng ˥ȥ꡼Ϥ */
  png_init_io(png_ptr, fp);

  /* ----- png פ */
  if (gdk_pixbuf_get_has_alpha(pic) == TRUE) {
    png_set_IHDR(png_ptr, info_ptr,     
                 gdk_pixbuf_get_width(pic),
                 gdk_pixbuf_get_height(pic),
                 8,
                 PNG_COLOR_TYPE_RGB_ALPHA,
                 PNG_INTERLACE_NONE,
                 PNG_COMPRESSION_TYPE_BASE,
                 PNG_FILTER_TYPE_BASE);
  }
  else {
    png_set_IHDR(png_ptr, info_ptr,     
                 gdk_pixbuf_get_width(pic),
                 gdk_pixbuf_get_height(pic),
                 8,
                 PNG_COLOR_TYPE_RGB,
                 PNG_INTERLACE_NONE,
                 PNG_COMPRESSION_TYPE_BASE,
                 PNG_FILTER_TYPE_BASE);
  }

  /* ----- ե᡼إåФ */
  png_write_info(png_ptr, info_ptr);

  /* ----- ԥФ */
  { 
    png_uint_32  k, height;
    png_bytep row_pointers[gdk_pixbuf_get_height(pic)];
    height = gdk_pixbuf_get_height(pic);
    for(k=0; k<height; k++) {
      row_pointers[k] = gdk_pixbuf_get_pixels(pic) +
        (gdk_pixbuf_get_rowstride(pic) * k);
    }
    png_write_image(png_ptr, row_pointers);
  }

  /* ----- 񤭽Фνλ */
  png_write_end(png_ptr, info_ptr);
  png_destroy_write_struct(&png_ptr, (png_infopp)NULL);

  fclose(fp);

  return;
}

