/* =====================================================================

   LiMo - Particle Effect Test 01
      Video Effect  - Particle Sprite.

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Sep.14.2001  Programing start (Particle test 01)

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  v_effect_init       -- եå饹ץ饤
  v_effect_free       -- ,λ
  v_effect_main       -- ѡƥ륹ץ饤

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdlib.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk-pixbuf/gdk-pixbuf-loader.h>
#include  "v_effect01.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define  PATTERN  0


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* --- 餬뤫ɤå */
gboolean ve_null_check(GdkPixbuf *chr, gint x, gint y);

/* --- ꡼˥ץ饤Ȥ */
void ve_sprite_put(GdkPixbuf *screen, VSprite *spr);

/* --- ֥ǥ */
guint32  ve_mix_pixel(guint32 src, guint32 dis, gint alpha);
guint32  ve_mix_pixel2(guint32 src, guint32 dis, gint alpha);

/* --- ѡƥºݤư */
void  ve_motion_01(VSprite *spr, gint timer);
void  ve_motion_02(VSprite *spr, gint timer);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ץ饤ȿ */
gint  spr_num, spr_max;

/* --- ץ饤ȹ¤() */
VSprite  *chr_sprite;


/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  v_effect_init       -- եå饹ץ饤

   return : void
   GdkPixbuf  *character  ץ饤Ȥθեå

-------------------------------------------------------------- */
void  v_effect_init(GdkPixbuf *character)
{
  gint  i, j;

  /* --- ץ饤ȥХåե 50Ĥ饹 */
  chr_sprite = g_malloc(sizeof(VSprite) * 50);
  spr_max = 50;
  spr_num = 0;

  /* --- 640x480(80x60chip) */
  for(i=0; i<60; i++) {
    for(j=0; j<80; j++) {
      if (ve_null_check(character, (j*8), (i*8)) == TRUE) {
	chr_sprite[spr_num].sw = TRUE;
	chr_sprite[spr_num].character = character;
	chr_sprite[spr_num].x = j * 8;
	chr_sprite[spr_num].y = i * 8;
	chr_sprite[spr_num].w = 8;
	chr_sprite[spr_num].h = 8;
	chr_sprite[spr_num].ox = j * 8;
	chr_sprite[spr_num].oy = i * 8;
	chr_sprite[spr_num].offset_x = j * 8;
	chr_sprite[spr_num].offset_y = i * 8;
	chr_sprite[spr_num].alpha = 0x00;
	chr_sprite[spr_num].org = (rand() / (RAND_MAX / 360));
	chr_sprite[spr_num].wave = 80 + (rand() / (RAND_MAX/ 80));
#if (PATTERN == 0)
	chr_sprite[spr_num].timer = -((spr_num) / 3);
	chr_sprite[spr_num].timer += (rand() / (RAND_MAX / 18)) - 9 -20;
#else
	chr_sprite[spr_num].timer = -((1150 - spr_num) / 3);
	chr_sprite[spr_num].timer += (rand() / (RAND_MAX / 18)) - 9 -20;
#endif
	spr_num++;
	if (spr_num == spr_max) {
	  /* --- ĥ */
	  spr_max += 50;
	  chr_sprite = g_realloc(chr_sprite, sizeof(VSprite) * spr_max);
	}
      }
    }
  }
  printf("spr_num : %d\n", spr_num);
}


/* -------------------------------------------------------------
  v_effect_free       -- ,λ

   return : void
   void

-------------------------------------------------------------- */
void  v_effect_free(void)
{
  g_free(chr_sprite);
}


/* -------------------------------------------------------------
  v_effect_main       -- ѡƥ륹ץ饤

   return : void
   GdkPixbuf  *screen  ϥ꡼
   gint        timer   ϥե졼

-------------------------------------------------------------- */
void  v_effect_main(GdkPixbuf *screen, gint timer)
{
  guint32  *adr;
  gint  i;

  /* --- ꡼Υꥢ */
  adr = (guint32*)gdk_pixbuf_get_pixels(screen);
  for(i=0; i<(640*480/8); i++) {
    *adr = 0x00000000;
    adr++;
    *adr = 0x00000000;
    adr++;
    *adr = 0x00000000;
    adr++;
    *adr = 0x00000000;
    adr++;
    *adr = 0x00000000;
    adr++;
    *adr = 0x00000000;
    adr++;
    *adr = 0x00000000;
    adr++;
    *adr = 0x00000000;
    adr++;
  }

  /* --- ѡƥΥ⡼ */
  for(i=0; i<spr_num; i++) {
    if (chr_sprite[i].sw == TRUE) {
#if (PATTERN == 0)
      ve_motion_01(&chr_sprite[i], timer);
#else
      ve_motion_02(&chr_sprite[i], timer);
#endif
    }
  }

  /* --- ץ饤Ȥɽ */
  for(i=0; i<spr_num; i++) {
    if (chr_sprite[i].sw == TRUE) {
      ve_sprite_put(screen, &chr_sprite[i]);
    }
  }
}



/* -----------------------------------------------------------------------
 --- ؿ
------------------------------------------------------------------------ */

/* -------------------------------------------
  餬뤫ɤå
-------------------------------------------- */
gboolean ve_null_check(GdkPixbuf *chr, gint x, gint y)
{
  gboolean  r;
  guint32   *adr, pixel;
  gint      i = 0, j = 0;

  r = FALSE;
  for(i=0; i<8; i++) {
    adr = (guint32*)gdk_pixbuf_get_pixels(chr);
    adr += x + ((y + i) * gdk_pixbuf_get_rowstride(chr)/ 4);
    for(j=0; j<8; j++) {
      pixel = ((*adr) & 0xff000000) >> 24;
      if (pixel != 0x00) {
	r = TRUE;
      }
      adr++;
    }
  }
  return(r);
}

/* -------------------------------------------
  ꡼˥ץ饤Ȥ
-------------------------------------------- */
void ve_sprite_put(GdkPixbuf *screen, VSprite *spr)
{
  gint  wh, wv, x, y;   /* -- ºݤž */
  gint  ox, oy;
  gint  i = 0, j;
  guint32  *pix_src1, *pix_src2, *pix_dis1, *pix_dis2;
  gint  src_w, dis_w;

  /* --- ϰϤȤϤ߽ФΥå */
  wh = wv = 8;
  ox = oy = 0;
  x = spr->x;
  y = spr->y;
  if (x < (-spr->w)) return;
  if (y < (-spr->h)) return;
  if (x >= gdk_pixbuf_get_width(screen)) return;
  if (y >= gdk_pixbuf_get_height(screen)) return;
  if (x < 0) {
    wh = (spr->w+x);
    ox = -x;
    x = 0;
  }
  if (y < 0) {
    wv = (spr->h+y);
    oy = -y;
    y = 0;
  }
  if (x >= (gdk_pixbuf_get_width(screen))) {
    wh = -(x - gdk_pixbuf_get_width(screen));
  }
  if (y >= (gdk_pixbuf_get_height(screen))) {
    wv = -(y - gdk_pixbuf_get_height(screen));
  }

  /* --- ž, */
  src_w = gdk_pixbuf_get_rowstride(spr->character) / 4;
  pix_src1 = (guint32*)gdk_pixbuf_get_pixels(spr->character);
  pix_src1 += spr->ox + ox + ((spr->oy + i + oy) * src_w);
  dis_w = gdk_pixbuf_get_rowstride(screen) / 4;
  pix_dis1 = (guint32*)gdk_pixbuf_get_pixels(screen);
  pix_dis1 += x + (y * dis_w);
  for(i=0; i<wv; i++) {
    pix_src2 = pix_src1;
    pix_dis2 = pix_dis1;
    for(j=0; j<wh; j++) {
      *pix_dis2 = ve_mix_pixel2(*pix_src2, *pix_dis2, spr->alpha);
      pix_src2++;
      pix_dis2++;
    }
    pix_src1 += src_w;
    pix_dis1 += dis_w;
  }
}


/* -------------------------------------------
 ֥ǥ (ǫ)
-------------------------------------------- */
guint32  ve_mix_pixel(guint32 src, guint32 dis, gint alpha)
{
  guint32  pix1, pix2, pix3, pix4;
  gint     src_a, dis_a;

  src_a = 0x100 - (alpha & 0xff);
  dis_a = 0x100 - src_a;
  if (src_a == 0xff) {
    src_a = 0x100;
    dis_a = 0;
  }
  pix1 = src & 0x00ff00ff;
  pix2 = (src & 0xff00ff00) >> 8;
  pix3 = dis & 0x00ff00ff;
  pix4 = (dis & 0xff00ff00) >> 8;
  pix2 ^= 0x00ff0000;
  pix4 ^= 0x00ff0000;
  pix1 *= src_a;
  pix2 *= src_a;
  pix3 *= dis_a;
  pix4 *= dis_a;
  pix1 += pix3;
  pix2 += pix4;
  pix1 &= 0xff00ff00;
  pix1 >>= 8;
  pix2 &= 0xff00ff00;
  pix1 |= pix2;
  pix1 ^= 0xff000000;

  return(pix1);
}


/* -------------------------------------------
 ֥ǥ (ǫ)
-------------------------------------------- */
guint32  ve_mix_pixel2(guint32 src, guint32 dis, gint alpha)
{
  guint32  pix1, pix2, pix3, pix4;
  gint     src_a, dis_a;

  src_a = 0x100 - (alpha & 0xff);
  dis_a = 0x100 - src_a;
  if (src_a == 0xff) {
    src_a = 0x100;
    dis_a = 0;
  }
  pix1 = src & 0x00ff00ff;
  pix2 = (src & 0xff00ff00) >> 8;
  pix3 = dis & 0x00ff00ff;
  pix4 = (dis & 0xff00ff00) >> 8;
  pix2 ^= 0x00ff0000;
  pix4 ^= 0x00ff0000;
  pix1 *= src_a;
  pix2 *= src_a;
  pix3 *= dis_a;
  pix4 *= dis_a;
  pix1 += pix3;
  pix2 += pix4;
  pix1 &= 0xff00ff00;
  pix1 >>= 8;
  pix2 &= 0xff00ff00;
  pix1 |= pix2;
  pix1 ^= 0xff000000;

  pix1 = (pix1 & 0xff000000) | (src & 0x00ffffff);

  return(pix1);
}


/* -------------------------------------------
  ѡƥºݤư
-------------------------------------------- */
void  ve_motion_01(VSprite *spr, gint timer)
{
  gint t, w;

  /* --- Ԥ */
  if ((spr->timer + timer) < 0) return;
  /* --- ä */
  if ((spr->timer + timer) >= 127) {
    spr->sw = FALSE;
    return;
  }

  /* --- ޡˤäַ׻ */
  t = timer + spr->timer;
  spr->y = spr->offset_y - t;
  w = (spr->timer + timer) * spr->wave / 100;
  spr->x = spr->offset_x + (gint)((double)w * (sin(2.0*3.141592653*(double)(t+spr->org)/60)));

  /* --- (Ʃ) */
  spr->alpha = (spr->timer + timer) * 2;
}


void  ve_motion_02(VSprite *spr, gint timer)
{
  gint t, w;

  /* --- Ԥ */
  if ((spr->timer + timer) < 0) return;
  /* --- ä */
  if ((spr->timer + timer) >= 127) {
    spr->sw = FALSE;
    return;
  }

  /* --- ޡˤäַ׻ */
  t = timer + spr->timer;
  spr->y = spr->offset_y + t;
  w = (spr->timer + timer) * spr->wave / 100;
  spr->x = spr->offset_x + (gint)((double)w * (sin(2.0*3.141592653*(double)(t+spr->org)/60)));

  /* --- (Ʃ) */
  spr->alpha = (spr->timer + timer) * 2;
}
